// Uninstall.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "Uninstall.h"
#include "Utility.h"
#include "PathMgr.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

void Uninstall() {
	PathMgr pathMgr;
	CString logPath = MakePath(pathMgr.GetAppRootDir(), UninstallLogFileName);
	CString logData = FileToString(logPath, false);
	StringVector log;
	StringListToStringVector(logData, TEXT("\r\n"), log);
	CString notRemoved;

	for (size_t i = 0; i < log.size(); ++i)
		if (!UninstallFile(log[i])) {
			notRemoved += log[i];
			notRemoved += '\n';
		}

	CString msg;
	UINT flags = MB_OK;

	if (notRemoved.IsEmpty()) {
		msg = TEXT("Uninstall completed successfully!");
		flags |= MB_ICONINFORMATION;
	} else {
		msg = TEXT("The following files or folders could not be removed:\n\n")
			+ notRemoved
			+ TEXT("\nThe uninstaller only deletes folders if they are empty. You may manually delete any remaining non-empty folders.");
		flags |= MB_ICONWARNING;
	}

#if 0
	// I decided against displaying the message about the user data folders being left
	// around as it uglies up the dialog considerably.
	CString suffix;
	suffix.Format(_T("\n\nNote: Lite Edit does not remove any user specific data folders such as '%s'. You may remove such folders manually."), (LPCTSTR)pathMgr.GetPerUserDataDir());
	msg += suffix;
#endif

	MessageBox(NULL, msg, TEXT("Finished"), flags);
}

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow) {
	if (MessageBox(NULL, TEXT("This will uninstall Lite Edit. Continue?"), TEXT("Uninstall"), MB_YESNO|MB_ICONINFORMATION) == IDYES)
		Uninstall();

	return 0;
}
